drawstats:
        movem.l d0-d7/a0-a6,-(a7)
        
        move.w #0,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7

        move.w #0,-(a7)
        move.l stats,-(a7)
        add.l #HANDS+12,(a7)
        move.w #STAT_NAME_Y,-(a7)
        move.w #STAT_NAME_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        
        move.w #STAT_FONT,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7

        move.l stats(pc),a0
        cmp.l #0,MORESTATS(a0)
        beq drawvegasstats

        move.l HANDS(a0),d0
        move.w d0,-(a7)
        move.l #strx_hands,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_HANDS_Y,-(a7)
        move.w #STAT_HANDS_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.l HANDS+4(a0),d0
        move.w d0,-(a7)
        move.l #strx_wins,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_WINS_Y,-(a7)
        move.w #STAT_WINS_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

;        move.l stats(pc),a0
;        move.l HANDS+8(a0),d0
;        move.w d0,-(a7)
;        move.l #strx_hiscore+75,-(a7)
;        move.l #tempstr,-(a7)
;        ROM_CALL romlib[sprintf]
;        add.l #10,a7
;        move.w #0,-(a7)
;        move.l #tempstr,-(a7)
;        move.w #66,-(a7)
;        move.w #32,-(a7)
;        ROM_CALL romlib[puttext]
;        add.l #10,a7

;        move.l stats(pc),a0
;        move.l GAMES(a0),d0
;        move.w d0,-(a7)
;        move.l #strx_hiscore+86,-(a7)
;        move.l #tempstr,-(a7)
;        ROM_CALL romlib[sprintf]
;        add.l #10,a7
;        move.w #0,-(a7)
;        move.l #tempstr,-(a7)
;        move.w #50,-(a7)
;        move.w #124,-(a7)
;        ROM_CALL romlib[puttext]
;        add.l #10,a7

        move.l stats(pc),a0
        move.l AVGSCORE(a0),d0
        move.l GAMES(a0),d1
        cmp.l #0,d1
        beq noavgscore
        divu.w d1,d0
        and.l #$ffff,d0
        move.w d0,-(a7)
        move.l #strx_avgscore,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_AVGSCORE_Y,-(a7)
        move.w #STAT_AVGSCORE_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
noavgscore:

        move.l stats(pc),a0
        move.l HANDS+4(a0),d0
        mulu.w #100,d0
        move.l HANDS(a0),d1
        cmp.l #0,d1
        beq nopct
        divu.w d1,d0
        and.l #$ffff,d0
        move.w d0,-(a7)
        move.l #strx_winpct,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_WINPCT_Y,-(a7)
        move.w #STAT_WINPCT_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
nopct:

        move.l stats(pc),a0
        move.l AVGSCORE+4(a0),d0
        move.l #strx_streaktype,-(a7)
        lsl.l #1,d0
        cmp.l #1,AVGSCORE+8(a0)
        beq streaktypedone
        add.l #1,d0
streaktypedone:
        lsl.l #3,d0
        add.l d0,(a7)
        move.l AVGSCORE+8(a0),d0
        move.w d0,-(a7)
        move.l #strx_streak,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #14,a7
;        move.w #120,d1
;        mulu.w #3,d0
;        sub.l d0,d1
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_STREAK_Y,-(a7)
        move.w #STAT_STREAK_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.l AVGSCORE+12(a0),d0
        move.w d0,-(a7)
        move.l #strx_streaklong,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #STAT_LONG_X,d1
        mulu.w #AVG_CHAR_WIDTH,d0
        sub.l d0,d1
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_LONG_Y,-(a7)
        move.w d1,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        cmp.w #9,fastwin_sec1
        bne fastwinok
        cmp.w #5,fastwin_sec10
        bne fastwinok
        cmp.w #9,fastwin_min
        bne fastwinok
        bra fastwinskip
fastwinok:
        move.w fastwin_sec1,-(a7)
        move.w fastwin_sec10,-(a7)
        move.w fastwin_min,-(a7)
        move.l #strx_fastwin,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #14,a7
        move.w #STAT_FAST_X,d1
        mulu.w #AVG_CHAR_WIDTH_DIV_2,d0
        sub.l d0,d1
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_FAST_Y,-(a7)
        move.w d1,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
fastwinskip:

        move.w totaltime_min,-(a7)
        move.w totaltime_hr,-(a7)
        move.l #strx_totaltime,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #12,a7
        move.w #STAT_TIME_X,d1
        mulu.w #AVG_CHAR_WIDTH_DIV_2,d0
        sub.l d0,d1
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_TIME_Y,-(a7)
        move.w d1,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.w #0,-(a7)
        move.l a0,-(a7)
        add.l #HINAME1,(a7)
        sub.l #3,(a7)
        move.w #STAT_HIGH1_Y,-(a7)
        move.w #STAT_HIGH_NAME_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.l stats(pc),a0
        move.l HISCORE1(a0),d0
        move.w d0,-(a7)
        move.l #strx_num,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_HIGH1_Y,-(a7)
        move.w #STAT_HIGH_SCORE_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.w #0,-(a7)
        move.l a0,-(a7)
        add.l #HINAME1+16,(a7)
        sub.l #3,(a7)
        move.w #STAT_HIGH2_Y,-(a7)
        move.w #STAT_HIGH_NAME_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.l stats(pc),a0
        move.l HISCORE1+4(a0),d0
        move.w d0,-(a7)
        move.l #strx_num,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_HIGH2_Y,-(a7)
        move.w #STAT_HIGH_SCORE_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.w #0,-(a7)
        move.l a0,-(a7)
        add.l #HINAME1+32,(a7)
        sub.l #3,(a7)
        move.w #STAT_HIGH3_Y,-(a7)
        move.w #STAT_HIGH_NAME_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.l stats(pc),a0
        move.l HISCORE1+8(a0),d0
        move.w d0,-(a7)
        move.l #strx_num,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_HIGH3_Y,-(a7)
        move.w #STAT_HIGH_SCORE_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        movem.l (a7)+,d0-d7/a0-a6
        rts

drawvegasstats:
        move.l HANDS(a0),d0
        move.w d0,-(a7)
        move.l #strx_num+4,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #VEGAS_HANDS_X,d1
        mulu.w #AVG_CHAR_WIDTH_DIV_2,d0
        sub.l d0,d1
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_HANDS_Y,-(a7)
        move.w d1,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.l HANDS+4(a0),d0
        move.w d0,-(a7)
        move.l #strx_num+16,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #VEGAS_WINS_X,d1
        mulu.w #AVG_CHAR_WIDTH_DIV_2,d0
        sub.l d0,d1
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_WINS_Y,-(a7)
        move.w d1,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.l HANDS+4(a0),d0
        mulu.w #100,d0
        move.l HANDS(a0),d1
        cmp.l #0,d1
        beq nopct2
        divu.w d1,d0
        and.l #$ffff,d0
        move.w d0,-(a7)
        move.l #strx_winpct,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #VEGAS_WINPCT_X,d1
        mulu.w #AVG_CHAR_WIDTH_DIV_2,d0
        sub.l d0,d1
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_STREAK_Y,-(a7)
        move.w d1,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
nopct2:

        cmp.w #9,fastwin_sec1
        bne fastwinok2
        cmp.w #5,fastwin_sec10
        bne fastwinok2
        cmp.w #9,fastwin_min
        bne fastwinok2
        bra fastwinskip2
fastwinok2:
        move.w fastwin_sec1,-(a7)
        move.w fastwin_sec10,-(a7)
        move.w fastwin_min,-(a7)
        move.l #strx_fastwin,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #14,a7
        move.w #STAT_FAST_X,d1
        mulu.w #AVG_CHAR_WIDTH_DIV_2,d0
        sub.l d0,d1
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_FAST_Y,-(a7)
        move.w d1,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
fastwinskip2:

        move.w totaltime_min,-(a7)
        move.w totaltime_hr,-(a7)
        move.l #strx_totaltime,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #12,a7
        move.w #STAT_TIME_X,d1
        mulu.w #AVG_CHAR_WIDTH_DIV_2,d0
        sub.l d0,d1
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_TIME_Y,-(a7)
        move.w d1,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.w #0,-(a7)
        move.l a0,-(a7)
        add.l #HINAME1,(a7)
        sub.l #3,(a7)
        move.w #STAT_HIGH1_Y,-(a7)
        move.w #VEGAS_HIGH_NAME_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.l stats(pc),a0
        move.l HISCORE1(a0),d0
        move.w d0,-(a7)
        move.l #strx_num+40,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_HIGH1_Y,-(a7)
        move.w #VEGAS_HIGH_SCORE_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.w #0,-(a7)
        move.l a0,-(a7)
        add.l #HINAME1+16,(a7)
        sub.l #3,(a7)
        move.w #STAT_HIGH2_Y,-(a7)
        move.w #VEGAS_HIGH_NAME_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.l stats(pc),a0
        move.l HISCORE1+4(a0),d0
        move.w d0,-(a7)
        move.l #strx_num+40,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_HIGH2_Y,-(a7)
        move.w #VEGAS_HIGH_SCORE_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.w #0,-(a7)
        move.l a0,-(a7)
        add.l #HINAME1+32,(a7)
        sub.l #3,(a7)
        move.w #STAT_HIGH3_Y,-(a7)
        move.w #VEGAS_HIGH_NAME_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.l stats(pc),a0
        move.l HISCORE1+8(a0),d0
        move.w d0,-(a7)
        move.l #strx_num+40,-(a7)
        move.l #tempstr,-(a7)
        jsr tios::sprintf
        add.l #10,a7
        move.w #0,-(a7)
        move.l #tempstr,-(a7)
        move.w #STAT_HIGH3_Y,-(a7)
        move.w #VEGAS_HIGH_SCORE_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        movem.l (a7)+,d0-d7/a0-a6
        rts


updatetotaltime:
        move.w #$700,d0
        trap #1
        move.w seconds,d1
        move.w d1,cur_sec
        move.w seconds1,d1
        move.w d1,cur_sec1
        move.w seconds10,d1
        move.w d1,cur_sec10
        move.w minutes,d1
        move.w d1,cur_min
        move.w minutes1,d1
        move.w d1,cur_min1
        move.w minutes10,d1
        move.w d1,cur_min10
        trap #1

        move.w cur_sec,d0
        add.w d0,totaltime_sec
        cmp.w #60,totaltime_sec
        blt us_secondsok
        sub.w #60,totaltime_sec
        add.w #1,totaltime_min
us_secondsok:
        move.w cur_min,d0
        add.w d0,totaltime_min
        cmp.w #60,totaltime_min
        blt us_minutesok
        sub.w #60,totaltime_min
        add.w #1,totaltime_hr
us_minutesok:
        rts


updatefastwin:
        move.w #0,fastestwin
        move.w cur_min,d0
        cmp.w fastwin_min,d0
        bgt fastwinend
        cmp.w fastwin_min,d0
        blt fastwinyes
        move.w cur_sec,d0
        cmp.w fastwin_sec,d0
        bge fastwinend
fastwinyes:
        move.w #1,fastestwin
        move.w cur_min,d0
        move.w d0,fastwin_min
        move.w cur_sec,d0
        move.w d0,fastwin_sec
        move.w cur_sec1,d0
        move.w d0,fastwin_sec1
        move.w cur_sec10,d0
        move.w d0,fastwin_sec10
fastwinend:
        rts


updatestats:
        movem.l d0-d7/a0-a6,-(a7)

        move.l stats(pc),a0
        add.l #1,HANDS(a0)
        add.l #1,GAMES(a0)
        add.l #1,HANDS+8(a0)
        move.l score(pc),d0
        add.l d0,AVGSCORE(a0)
        divu.w #52,d0
        and.l #$ffff,d0
        add.l d0,HANDS(a0)
        add.l d0,HANDS+4(a0)
        cmp.l #0,d0
        beq updatestatsloss

        cmp.l #1,AVGSCORE+4(a0)
        beq updatestatsanotherwin
        move.l #1,AVGSCORE+4(a0)
        move.l #0,AVGSCORE+8(a0)
updatestatsanotherwin:
        add.l #1,AVGSCORE+8(a0)
;        bra updatestatsdone

updatestatsloss:
        cmp.l #0,AVGSCORE+4(a0)
        beq updatestatsanotherloss
        move.l #0,AVGSCORE+4(a0)
        move.l #0,AVGSCORE+8(a0)
updatestatsanotherloss:
        add.l #1,AVGSCORE+8(a0)
        move.l AVGSCORE+8(a0),d0
        move.l AVGSCORE+12(a0),d1
        cmp.l d1,d0
        ble updatestatsdone
        move.l d0,AVGSCORE+12(a0)

updatestatsdone:
        movem.l (a7)+,d0-d7/a0-a6
        rts

updatevegasstats:
        movem.l d0-d7/a0-a6,-(a7)

        move.l stats(pc),a0
        add.l #1,HANDS(a0)
        move.l score(pc),d0
        move.l goal(pc),d1
        cmp.l d1,d0
        bne vegasloss

        add.l #1,HANDS+4(a0)
        movem.l (a7)+,d0-d7/a0-a6
        rts

vegasloss:
        add.l #1,HANDS+8(a0)
        movem.l (a7)+,d0-d7/a0-a6
        rts
